# coding: utf-8

"""
    VRt.Packer [PC]

    Veeroute Packer API.  # Description  The service is designed to calculate the placement of goods inside given packages.  ## Types of packages  ### Pallet  ![pallet](../images/packer_pallet.svg)  *Mono-pallet*  If the pallet is fully equipped with the same product, then such a pallet is called **mono-pallet**, such a pallet has the following loading rules:  1. The maximum allowable height of the pallet with the goods laid on it is taken into account. 1. The maximum allowable weight of the loaded pallet is taken into account. 1. Goods packages can only be stacked parallel to the walls of the pallet. 1. It is allowed to rotate packages around the vertical Z-axis and only at a right angle. 1. In order to equalize the height between the positions (to place another pallet on top), empty spaces can be added to the stacking by layers.  *Zone tray*  After the formation of mono-pallets, the remaining part of the goods of the same article is placed on the next pallet, which is divided into zones by means of a cardboard partition in such a way that only one item of goods is placed in each zone, while the zones have the following restrictions:  1. The zones are rectangular. 1. The ratio between the sides of the zones can be any. 1. One of the sides of any zone is always in contact with the edge of the pallet. 1. Permissible number of zones on a pallet: from 2 to 6. 1. Each zone is filled according to the rules for filling a mono-pallet. 1. The stacking height of all goods does not exceed 50 mm, so that another pallet can be placed on top of such a pallet. 1. It is allowed to form pallets with different stacking heights for different positions (height difference is more than 50 mm), if these are the top pallets in the stack.  ### Mixbox  ![mixbox](../images/packer_mixbox.svg)  If the above steps fail to place the item in this way, so that the pallet is of the required height or weight, mixboxes are used:  1. Mixbox can only be placed in one layer. 1. Different goods can be placed in one mixbox, in this case it is divided by partitions similarly to a pallet (the only difference is that the height of the packed goods is not aligned). 1. Mixboxes can be mixed with items on the same pallet. 1. One product can be packed in different mixboxes.  ### Slot  ![slot](../images/packer_slot.svg)  The loaded pallets are stacked on top of each other, the slot is where the stack of pallets is placed. The slot has no physical body - so the dimensions of the `body` of the slot are zero.  ## Coordinate system  ![coordinates](../images/packer_coordinates.svg)  To indicate the location of packages and goods, a local coordinate system is used, in which the coordinates of a particular object are indicated relative to the near left lower corner of the parent object, while:  * Horizontal plane - axes **X**, **Y** * Vertical - **Z** axis  The ratio of the axes of goods and packages:  * Width - **X** * Length - **Y** * Height - **Z**  ## Entity diagram  ![erd](../uml/packer.svg)

    The version of the OpenAPI document: 7.0.2395
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class EntityErrorType(str, Enum):
    """
    Error type:   * `UNIQUE_IDS_VIOLATION` - all keys must be unique   * `INCONSISTENT_REFERENCE` - bad reference key   * `INVALID_SLOTS_COUNT` - exactly one SLOT package must be present   * `INVALID_SLOT_CONTAINER` - slot container_coordinates must be zero   * `INVALID_SLOT_BODY` - slot body_dimensions must be zero   * `INVALID_PALLETS_COUNT` - exactly one PALLET package must be present   * `INVALID_PALLET_CONTAINER_DIMENSIONS` - the length and width of a pallet container_dimensions must not exceed the corresponding body_dimensions   * `INVALID_PALLET_CONTAINER` - the pallet container must not go beyond the boundaries of the pallet body in length and width   * `INVALID_MIXBOX_CONTAINER` - mixbox container must be inside body subject to container_coordinates offset   * `INVALID_MIXBOX_COUNT` - at least one valid MIXBOX package must be present   * `INVALID_PRODUCT_DIMENSIONS` - product length, width and height must be at least 1 millimeter, weight - at least 1 gram   * `INVALID_PRODUCT_COUNT` - at least one valid product must be present 
    """

    """
    allowed enum values
    """
    UNIQUE_IDS_VIOLATION = 'UNIQUE_IDS_VIOLATION'
    INCONSISTENT_REFERENCE = 'INCONSISTENT_REFERENCE'
    INVALID_SLOTS_COUNT = 'INVALID_SLOTS_COUNT'
    INVALID_SLOT_CONTAINER = 'INVALID_SLOT_CONTAINER'
    INVALID_SLOT_BODY = 'INVALID_SLOT_BODY'
    INVALID_PALLETS_COUNT = 'INVALID_PALLETS_COUNT'
    INVALID_PALLET_CONTAINER_DIMENSIONS = 'INVALID_PALLET_CONTAINER_DIMENSIONS'
    INVALID_PALLET_CONTAINER = 'INVALID_PALLET_CONTAINER'
    INVALID_MIXBOX_CONTAINER = 'INVALID_MIXBOX_CONTAINER'
    INVALID_MIXBOX_COUNT = 'INVALID_MIXBOX_COUNT'
    INVALID_PRODUCT_DIMENSIONS = 'INVALID_PRODUCT_DIMENSIONS'
    INVALID_PRODUCT_COUNT = 'INVALID_PRODUCT_COUNT'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of EntityErrorType from a JSON string"""
        return cls(json.loads(json_str))


